registerForEvent("onInit", function ()
    ns = Game.GetNavigationSystem()
    player = Game.GetPlayer()
    curPos = player:GetWorldPosition()
    updateTimerTick = 0.25 -- in seconds
    elapsedDelta = 0
    vehicleCheckTick = 5
    vehicleCheckDelta = 0

    function ftos(number)
        return string.format( "%.3f", number)
    end

    function vecToString(vec4)
        return "x: " .. ftos(vec4.x) .. " y: " .. ftos(vec4.y) .. " z: " .. ftos(vec4.z)
    end

    function isInVehicle()
        return Game['GetMountedVehicle;GameObject'](player)
    end

    print("NavMod initialized!")
end)

registerForEvent("onUpdate", function (timeDelta)
    elapsedDelta = elapsedDelta + timeDelta
    vehicleCheckDelta = vehicleCheckDelta + timeDelta

    if elapsedDelta >= updateTimerTick then
        curPos = player:GetWorldPosition()
        -- print(vecToString(curPos))
        elapsedDelta = 0
    end

    if vehicleCheckDelta >= vehicleCheckTick then
        -- veh = isInVehicle()
        vehicleCheckDelta = 0
    end

end)

registerForEvent("onDraw", function ()
    
    if ImGui.Begin("NavMod") then
        ImGui.SetWindowSize(400, 50)
        if ImGui.SmallButton("To Clipboard") then
            ImGui.SetClipboardText(vecToString(curPos))
        end
        ImGui.SameLine()
        ImGui.Text(vecToString(curPos))
        ImGui.End()
    end
end)